Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/SimpleFileSystemConnector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/SimpleFileSystemConnector.java	(revision 2587)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/SimpleFileSystemConnector.java	(revision 2588)
@@ -72,5 +72,5 @@
 		// create user's default dir
 		SimpleFileSystemConnector.servletContext = servletContext;
-		String realDefaultUserFilesPath = SimpleFileSystemConnector.servletContext.getRealPath(ConnectorHandler.getDefaultUserFilesPath());
+		String realDefaultUserFilesPath = SimpleFileSystemConnector.servletContext.getRealPath(ConnectorHandler.getUserFilesPath());
 		File defaultUserFilesDir = new File(realDefaultUserFilesPath);
 		UtilsFile.checkDirAndCreate(defaultUserFilesDir);
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java	(revision 2587)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java	(revision 2588)
@@ -21,13 +21,13 @@
 package net.fckeditor.handlers;
 
+import net.fckeditor.connector.Connector;
+
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
-
-import net.fckeditor.connector.Connector;
-import net.fckeditor.requestcycle.UserPathBuilder;
 
 /**
  * Handler for Connector-related properties.<br />
  * Wraps to the {@link PropertiesLoader}.
+ * TODO improve documentation of the property key mapping
  * 
  * @version $Id$
@@ -41,4 +41,5 @@
 		
 		// try to instantiate the Connector object
+		// TODO create a better property
 		String fqcn = PropertiesLoader.getProperty("connector.implementation");
 		if (fqcn == null)
@@ -57,14 +58,19 @@
 
 	/**
-	 * Getter for the <code>UserFilesPath</code>.<br>
-	 * Should be use in the implementations of {@link Connector}.
+	 * Getter for the <code>UserFilesPath</code>.
 	 * 
-	 * @return {@link UserPathBuilder#getUserFilesPath()} or
-	 *         the <code>DefaultUserFilePath</code> if {@link UserPathBuilder}
-	 *         isn't set.
+	 * @return UserFilePath
 	 */
 	public static String getUserFilesPath() {
-    	String userFilePath = RequestCycleHandler.getUserFilesPath();
-    	return (userFilePath != null) ? userFilePath : getDefaultUserFilesPath();
+		return PropertiesLoader.getProperty("connector.userFilesPath");
+    }
+	
+	/**
+	 * Getter for the <code>UserFilesAbsolutePath</code>.
+	 * 
+	 * @return UserFilesAbsolutePath
+	 */
+	public static String getUserFilesAbsolutePath() {
+		return PropertiesLoader.getProperty("connector.userFilesAbsolutePath");
     }
 
@@ -79,28 +85,4 @@
 	}
 
-	/**
-	 * Getter for the value to instruct the connector to return the full URL of
-	 * a file/folder in the XML response rather than the absolute URL.
-	 * 
-	 * @return <code>true</code> if the property <code>connector.fullUrl</code> is
-	 *         set else <code>false</code>.
-	 */
-	public static boolean isFullUrl() {
-		return Boolean.parseBoolean(PropertiesLoader.getProperty("connector.fullUrl"));
-	}
-	
-	public static String getBaseUrl() {
-		return PropertiesLoader.getProperty("connector.baseUrl");
-	}
-
-	/**
-	 * Getter for the default <code>UserFilesPath</code>.
-	 * 
-	 * @return <code>DefaultUserFilesPath</code> (/userfiles)
-	 */
-	public static String getDefaultUserFilesPath() {
-		return PropertiesLoader.getProperty("connector.userFilesPath");
-	}
-	
 	/**
 	 * Getter for the value to instruct the Connector to check if the uploaded
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/LocalizedPropertiesLoader.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/LocalizedPropertiesLoader.java	(revision 2587)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/LocalizedPropertiesLoader.java	(revision 2588)
@@ -93,4 +93,5 @@
 						.getClass());
 			} catch (Exception e) {
+				// TODO align message to other warnings
 				logger.warn(
 						"Error while loading LocaleResolver implementation", e);
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/RequestCycleHandler.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/RequestCycleHandler.java	(revision 2587)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/RequestCycleHandler.java	(revision 2588)
@@ -68,4 +68,5 @@
 				logger.info("UserPathBuilder initialized to {}", userPathBuilder.getClass());
 			} catch (Exception e) {
+				// TODO align message with others
 				logger.error("Couldn't instantiate class [".concat(fqcn)
 				        .concat("], The 'DefaultUserFilesPath' will be used in the ConnectorServlet!"), e);
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/Context.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/Context.java	(revision 2587)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/Context.java	(revision 2588)
@@ -114,11 +114,4 @@
     	StringBuffer sb = new StringBuffer();
     	HttpServletRequest request = ThreadLocalData.getServletRequest();
-
-		if (Utils.isNotEmpty(ConnectorHandler.getBaseUrl())) {
-			sb.append(ConnectorHandler.getBaseUrl());
-		} else if (ConnectorHandler.isFullUrl()) {
-    		String address = request.getRequestURL().toString();
-    		sb.append(address.substring(0, address.indexOf('/', 8)));
-    	}
     	    	
     	sb.append(baseDir);
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserPathBuilder.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserPathBuilder.java	(revision 2587)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserPathBuilder.java	(revision 2588)
@@ -58,4 +58,4 @@
 	 * @return
 	 */
-	public String getLocalUserFilesPath();
+	public String getUserFilesAbsolutePath();
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ContextPathBuilder.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ContextPathBuilder.java	(revision 2587)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ContextPathBuilder.java	(revision 2588)
@@ -38,5 +38,5 @@
 	 */
 	public String getUserFilesPath() {
-		String path = ThreadLocalData.getServletRequest().getContextPath().concat(ConnectorHandler.getDefaultUserFilesPath());
+		String path = ThreadLocalData.getServletRequest().getContextPath().concat(ConnectorHandler.getUserFilesPath());
 		return path;
 	}
@@ -45,6 +45,6 @@
 	 * @see net.fckeditor.requestcycle.UserPathBuilder#getLocalUserFilesPath()
 	 */
-	public String getLocalUserFilesPath() {
-		return ConnectorHandler.getDefaultUserFilesPath();
+	public String getUserFilesAbsolutePath() {
+		return ConnectorHandler.getUserFilesPath();
 	}
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tool/UtilsResponse.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tool/UtilsResponse.java	(revision 2587)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tool/UtilsResponse.java	(revision 2588)
@@ -40,9 +40,5 @@
 	public static String constructResponseUrl(String filePath, String resourceTypePath, String urlPath) {
 		StringBuffer sb = new StringBuffer();
-		
-		if (Utils.isNotEmpty(ConnectorHandler.getBaseUrl())) {
-			sb.append(ConnectorHandler.getBaseUrl());
-		}
-		    	
+		   	
 		sb.append(filePath);
 		if (Utils.isNotEmpty(resourceTypePath))
Index: FCKeditor.Java/trunk/java-core/src/main/resources/net/fckeditor/handlers/default.properties
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/resources/net/fckeditor/handlers/default.properties	(revision 2587)
+++ FCKeditor.Java/trunk/java-core/src/main/resources/net/fckeditor/handlers/default.properties	(revision 2588)
@@ -39,10 +39,9 @@
 connector.forceSingleExtension = true
 
-# base directory for the user files relative to the context root
+# base URL path for the userfiles
 connector.userFilesPath = /userfiles
 
-# Instructs the Connector to return the full URL of a file/folder in the XML
-# response rather than the absolute URL
-connector.fullUrl = false
+# base system path on the backend for the userfiles
+connector.userFilesAbsolutePath = /userfiles
 
 # Instructs the Connector to check, if the uploaded image is really one
Index: FCKeditor.Java/trunk/src/site/apt/properties.apt
===================================================================
--- FCKeditor.Java/trunk/src/site/apt/properties.apt	(revision 2587)
+++ FCKeditor.Java/trunk/src/site/apt/properties.apt	(revision 2588)
@@ -121,15 +121,19 @@
 |								| swf\|tif\|tiff\|wav\|wma\|wmv				|							|													|
 *-------------------------------+-------------------------------------------+---------------------------+---------------------------------------------------+
-| connector.userFilesPath		| /userfiles								| any path					| Indicates the path where files are stored.		|
+| connector.userFilesPath		| /userfiles								| any path					| Indicates the URL path under which files can be	|
+|								|											|							| retrieved from the server. Prepend the domain		|
+|								|											|							| name if you want to have the full URL. For more	|
+|								|											|							| details see {{{userpathsbuilder.html}here}}.		|
+*-------------------------------+-------------------------------------------+---------------------------+---------------------------------------------------+
+| connector.userFilesAbsolutePath| /userfiles								| any path					| Indicates the system path under which files can	|
+|								|											|							| be stored on the backend. For more details see	|
+|								|											|							| {{{userpathsbuilder.html}here}}.					|
 *-------------------------------+-------------------------------------------+---------------------------+---------------------------------------------------+
 | connector.forceSingleExtension| true										| true, false (boolean)		| Indicates whether filenames with multiple 		|
 |								|											|							| extensions are sanitized.							|
 *-------------------------------+-------------------------------------------+-------------------------- +---------------------------------------------------+
-| connector.fullUrl      		| false										| true, false (boolean)		| Indicates whether the domain name will be			|
-|								|											|							| prepended. E.g. <<<http://www.mysite.com>>>		|
-*-------------------------------+-------------------------------------------+---------------------------+---------------------------------------------------+
 | connector.secureImageUploads	|true										| true, false (boolean)		| Checks uploaded images for validity.				|
 |								|											|							| I.e. the uploaded file is a real image and not any|
-|								|											|							| other renamed file type.							|
+|								|											|							| other renamed file type. (magic bytes check)		|
 *-------------------------------+-------------------------------------------+---------------------------+---------------------------------------------------+
 | connector.userActionImpl		| {{{java-core/apidocs/net/fckeditor/requestcycle/impl/DisabledUserAction.html}<<<net.fckeditor.requestcycle. | any fully-qualified class	| Provides custom security functions for the File	|