Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserPathBuilder.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserPathBuilder.java	(revision 2591)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/UserPathBuilder.java	(revision 2592)
@@ -34,4 +34,12 @@
 
 	/**
+	 * Path needed to map resources to paths outside context of your webapp.
+	 * If the implementation don't bother you, just return <code>null</code>.
+	 * 
+	 * @return
+	 */
+	public String getUserFilesAbsolutePath(final HttpServletRequest request);
+	
+	/**
 	 * Getter for the user-dependent <code>UserFilesPath</code>.<br />
 	 * <strong>Important:</strong>
@@ -51,11 +59,3 @@
 	 */
 	public String getUserFilesPath(final HttpServletRequest request);
-	
-	/**
-	 * Path needed to map resources to paths outside context of your webapp.
-	 * If the implementation don't bother you, just return <code>null</code>.
-	 * 
-	 * @return
-	 */
-	public String getUserFilesAbsolutePath(final HttpServletRequest request);
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ContextPathBuilder.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ContextPathBuilder.java	(revision 2591)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ContextPathBuilder.java	(revision 2592)
@@ -23,7 +23,4 @@
 import javax.servlet.http.HttpServletRequest;
 
-import net.fckeditor.handlers.ConnectorHandler;
-import net.fckeditor.requestcycle.UserPathBuilder;
-
 /**
  * This implementation always returns the context path with the UserFilesPath
@@ -33,18 +30,16 @@
  * 
  */
-public class ContextPathBuilder implements UserPathBuilder {
+public class ContextPathBuilder extends ServerRootPathBuilder {
 
-	/* (non-Javadoc)
+	/*
+	 * (non-Javadoc)
+	 * 
 	 * @see net.fckeditor.requestcycle.UserPathBuilder#getUserFilesPath()
 	 */
 	public String getUserFilesPath(final HttpServletRequest request) {
-		return request.getContextPath().concat(ConnectorHandler.getUserFilesPath());
+		// TODO user needs the possibility to have the full url and the dynamic
+		// context name
+		return request.getContextPath().concat(super.getUserFilesPath(request));
 	}
-	
-	/* (non-Javadoc)
-	 * @see net.fckeditor.requestcycle.UserPathBuilder#getLocalUserFilesPath()
-	 */
-	public String getUserFilesAbsolutePath(final HttpServletRequest request) {
-		return ConnectorHandler.getUserFilesAbsolutePath();
-	}
+
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ServerRootPathBuilder.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ServerRootPathBuilder.java	(revision 2592)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/requestcycle/impl/ServerRootPathBuilder.java	(revision 2592)
@@ -0,0 +1,39 @@
+package net.fckeditor.requestcycle.impl;
+
+import javax.servlet.http.HttpServletRequest;
+
+import net.fckeditor.handlers.ConnectorHandler;
+import net.fckeditor.requestcycle.UserPathBuilder;
+
+/**
+ * This implementation always returns the UserFilesPath from the properties file
+ * absolute to the server root URL.
+ * 
+ * @version $Id$
+ * 
+ */
+public class ServerRootPathBuilder implements UserPathBuilder {
+
+	/*
+	 * (non-Javadoc)
+	 * 
+	 * @see
+	 * net.fckeditor.requestcycle.UserPathBuilder#getUserFilesAbsolutePath(javax
+	 * .servlet.http.HttpServletRequest)
+	 */
+	public String getUserFilesAbsolutePath(HttpServletRequest request) {
+		return ConnectorHandler.getUserFilesAbsolutePath();
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * 
+	 * @see
+	 * net.fckeditor.requestcycle.UserPathBuilder#getUserFilesPath(javax.servlet
+	 * .http.HttpServletRequest)
+	 */
+	public String getUserFilesPath(HttpServletRequest request) {
+		return ConnectorHandler.getUserFilesPath();
+	}
+
+}