Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java	(revision 2654)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java	(revision 2655)
@@ -22,4 +22,5 @@
 
 import net.fckeditor.connector.Connector;
+import net.fckeditor.tool.Utils;
 
 import org.slf4j.Logger;
@@ -28,28 +29,31 @@
 /**
  * Handler for Connector-related properties.<br />
- * Wraps to the {@link PropertiesLoader}.
- * TODO improve documentation of the property key mapping
+ * Wraps to the {@link PropertiesLoader}. TODO improve documentation of the
+ * property key mapping
  * 
  * @version $Id$
  */
 public class ConnectorHandler {
-	
-	private static Logger logger = LoggerFactory.getLogger(ConnectorHandler.class);
+
+	private static Logger logger = LoggerFactory
+			.getLogger(ConnectorHandler.class);
 	private static Connector connector = null;
-	
+
 	static {
-		
+
 		// try to instantiate the Connector object
-		String fqcn = PropertiesLoader.getProperty("connector.impl");
-		if (fqcn == null)
-			logger.warn("No property found for Connector implementation, any user action will be disabled!");
+		String className = PropertiesLoader.getProperty("connector.impl");
+		if (Utils.isEmpty(className))
+			logger.error("Empty Connector implementation class name provided");
 		else {
 			try {
-				Class<?> clazz = Class.forName(fqcn);
+				Class<?> clazz = Class.forName(className);
 				connector = (Connector) clazz.newInstance();
-				logger.info("Connector initialized to {}", connector.getClass());
+				logger.info("Connector initialized to {}", className);
 			} catch (Exception e) {
-				logger.error("Couldn't instantiate class [".concat(fqcn).concat(
-				        "], any user action will disabled!"), e);
+				logger
+						.error(
+								"Connector implementation {} could not be instantiated",
+								className);
 			}
 		}
@@ -63,6 +67,6 @@
 	public static String getUserFilesPath() {
 		return PropertiesLoader.getProperty("connector.userFilesPath");
-    }
-	
+	}
+
 	/**
 	 * Getter for the <code>UserFilesAbsolutePath</code>.
@@ -72,5 +76,5 @@
 	public static String getUserFilesAbsolutePath() {
 		return PropertiesLoader.getProperty("connector.userFilesAbsolutePath");
-    }
+	}
 
 	/**
@@ -81,5 +85,6 @@
 	 */
 	public static boolean isForceSingleExtension() {
-		return Boolean.valueOf(PropertiesLoader.getProperty("connector.forceSingleExtension"));
+		return Boolean.valueOf(PropertiesLoader
+				.getProperty("connector.forceSingleExtension"));
 	}
 
@@ -92,5 +97,6 @@
 	 */
 	public static boolean isSecureImageUploads() {
-		return Boolean.valueOf(PropertiesLoader.getProperty("connector.secureImageUploads"));
+		return Boolean.valueOf(PropertiesLoader
+				.getProperty("connector.secureImageUploads"));
 	}
 
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/LocalizedPropertiesLoader.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/LocalizedPropertiesLoader.java	(revision 2654)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/LocalizedPropertiesLoader.java	(revision 2655)
@@ -31,4 +31,5 @@
 
 import net.fckeditor.localization.LocaleResolver;
+import net.fckeditor.tool.Utils;
 
 import org.slf4j.Logger;
@@ -40,6 +41,5 @@
  * strings if anything fails. Loaded strings will be cached on load.
  * 
- * @version $Id: LocalizedPropertiesLoader.java 2630 2008-11-05 21:30:52Z
- *          mosipov $
+ * @version $Id$
  * 
  */
@@ -91,14 +91,18 @@
 					.getProperty("localization.localeResolverImpl");
 
-			try {
-				Class<?> clazz = Class.forName(className);
-				localeResolver = (LocaleResolver) clazz.newInstance();
-				logger.info("LocaleResolver initialized to {}", localeResolver
-						.getClass());
-			} catch (Exception e) {
-				// TODO align message to other warnings
-				logger.warn(
-						"Error while loading LocaleResolver implementation", e);
-			}
+			if (Utils.isEmpty(className))
+				logger
+						.error("Empty LocaleResolver implementation class name provided");
+			else
+				try {
+					Class<?> clazz = Class.forName(className);
+					localeResolver = (LocaleResolver) clazz.newInstance();
+					logger.info("LocaleResolver initialized to {}", className);
+				} catch (Exception e) {
+					logger
+							.error(
+									"LocaleResolver implementation {} could not be instantiated",
+									className);
+				}
 		}
 
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/RequestCycleHandler.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/RequestCycleHandler.java	(revision 2654)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/RequestCycleHandler.java	(revision 2655)
@@ -21,9 +21,9 @@
 package net.fckeditor.handlers;
 
-
 import javax.servlet.http.HttpServletRequest;
 
 import net.fckeditor.requestcycle.UserAction;
 import net.fckeditor.requestcycle.UserPathBuilder;
+import net.fckeditor.tool.Utils;
 
 import org.slf4j.Logger;
@@ -37,40 +37,47 @@
  */
 public class RequestCycleHandler {
-	private static Logger logger = LoggerFactory.getLogger(RequestCycleHandler.class);
+	private static Logger logger = LoggerFactory
+			.getLogger(RequestCycleHandler.class);
 	private static UserAction userAction = null;
 	private static UserPathBuilder userPathBuilder = null;
 
 	static {
-		// If there are more objects to instantiate in future, we could solve the following by reflection!
-				
+		// If there are more objects to instantiate in future, we could solve
+		// the following by reflection!
+
 		// 1. try to instantiate the UserAction object
-		String fqcn = PropertiesLoader.getProperty("connector.userActionImpl");
-		if (fqcn == null)
-			logger.warn("No property found for UserAction implementation, any user action will be disabled!");
+		String className = PropertiesLoader
+				.getProperty("connector.userActionImpl");
+		if (Utils.isEmpty(className))
+			logger.error("Empty UserAction implementation class name provided");
 		else {
 			try {
-				Class<?> clazz = Class.forName(fqcn);
+				Class<?> clazz = Class.forName(className);
 				userAction = (UserAction) clazz.newInstance();
-				logger.info("UserAction initialized to {}", userAction.getClass());
+				logger.info("UserAction initialized to {}", className);
 			} catch (Exception e) {
-				logger.error("Couldn't instantiate class [".concat(fqcn).concat(
-				        "], any user action will disabled!"), e);
+				logger
+						.error(
+								"UserAction implementation {} could not be instantiated",
+								className);
 			}
 		}
 
 		// 2. try to instantiate the UserPathBuilder object
-		fqcn = PropertiesLoader.getProperty("connector.userPathBuilderImpl");
-		if (fqcn == null)
-			logger.warn("No property found for UserPathBuilder implementation! "
-					.concat("The 'DefaultUserFilesPath' will be used in the ConnectorServlet!"));
+		className = PropertiesLoader
+				.getProperty("connector.userPathBuilderImpl");
+		if (Utils.isEmpty(className))
+			logger
+					.error("Empty UserPathsBuilder implementation class name provided");
 		else {
 			try {
-				Class<?> clazz = Class.forName(fqcn);
+				Class<?> clazz = Class.forName(className);
 				userPathBuilder = (UserPathBuilder) clazz.newInstance();
-				logger.info("UserPathBuilder initialized to {}", userPathBuilder.getClass());
+				logger.info("UserPathsBuilder initialized to {}", className);
 			} catch (Exception e) {
-				// TODO align message with others
-				logger.error("Couldn't instantiate class [".concat(fqcn)
-				        .concat("], The 'DefaultUserFilesPath' will be used in the ConnectorServlet!"), e);
+				logger
+						.error(
+								"UserPathsBuilder implementation {} could not be instantiated",
+								className);
 			}
 		}
@@ -78,34 +85,37 @@
 
 	/**
-	 * Just a wrapper to
-	 * {@link UserAction#isEnabledForFileBrowsing()}.
+	 * Just a wrapper to {@link UserAction#isEnabledForFileBrowsing()}.
 	 * 
-	 * @return {@link UserAction#isEnabledForFileBrowsing()}
-	 *         or false if {@link UserAction} isn't set.
+	 * @return {@link UserAction#isEnabledForFileBrowsing()} or false if
+	 *         {@link UserAction} isn't set.
 	 */
-	public static boolean isEnabledForFileBrowsing(final HttpServletRequest request) {
-		return (userAction != null && userAction.isEnabledForFileBrowsing(request));
+	public static boolean isEnabledForFileBrowsing(
+			final HttpServletRequest request) {
+		return (userAction != null && userAction
+				.isEnabledForFileBrowsing(request));
 	}
 
 	/**
-	 * Just a wrapper to
-	 * {@link UserAction#isEnabledForFileUpload()}.
+	 * Just a wrapper to {@link UserAction#isEnabledForFileUpload()}.
 	 * 
-	 * @return {@link UserAction#isEnabledForFileUpload()} or
-	 *         false if {@link UserAction} isn't set.
+	 * @return {@link UserAction#isEnabledForFileUpload()} or false if
+	 *         {@link UserAction} isn't set.
 	 */
-	public static boolean isEnabledForFileUpload(final HttpServletRequest request) {
-		return (userAction != null && userAction.isEnabledForFileUpload(request));
+	public static boolean isEnabledForFileUpload(
+			final HttpServletRequest request) {
+		return (userAction != null && userAction
+				.isEnabledForFileUpload(request));
 	}
 
 	/**
-	 * Just a wrapper to
-	 * {@link UserAction#isEnabledForFolderCreation()}.
+	 * Just a wrapper to {@link UserAction#isEnabledForFolderCreation()}.
 	 * 
-	 * @return {@link UserAction#isEnabledForFolderCreation()} or
-	 *         false if {@link UserAction} isn't set.
+	 * @return {@link UserAction#isEnabledForFolderCreation()} or false if
+	 *         {@link UserAction} isn't set.
 	 */
-	public static boolean isEnabledForFolderCreation(final HttpServletRequest request) {
-		return (userAction != null && userAction.isEnabledForFolderCreation(request));
+	public static boolean isEnabledForFolderCreation(
+			final HttpServletRequest request) {
+		return (userAction != null && userAction
+				.isEnabledForFolderCreation(request));
 	}
 
@@ -115,13 +125,12 @@
 	 * 
 	 * @param request
-	 * @return {@link UserPathBuilder#getUserFilesPath()} or
-	 *         <code>null</code> if <code>userPathBuilder</code> is
-	 *         <code>null</code>.
+	 * @return {@link UserPathBuilder#getUserFilesPath()} or <code>null</code>
+	 *         if <code>userPathBuilder</code> is <code>null</code>.
 	 */
 	public static String getUserFilesPath(final HttpServletRequest request) {
-		return (userPathBuilder != null) ? userPathBuilder.getUserFilesPath(request) : null;
+		return (userPathBuilder != null) ? userPathBuilder
+				.getUserFilesPath(request) : null;
 	}
-	
-	
+
 	/**
 	 * 
@@ -129,6 +138,8 @@
 	 * @return
 	 */
-	public static String getUserFilesAbsolutePath(final HttpServletRequest request) {
-		return (userPathBuilder != null) ? userPathBuilder.getUserFilesAbsolutePath(request) : null;
+	public static String getUserFilesAbsolutePath(
+			final HttpServletRequest request) {
+		return (userPathBuilder != null) ? userPathBuilder
+				.getUserFilesAbsolutePath(request) : null;
 	}
 }