Index: FCKeditor.Java/trunk/src/site/apt/upgrade_notes.apt.vm
===================================================================
--- FCKeditor.Java/trunk/src/site/apt/upgrade_notes.apt.vm	(revision 2701)
+++ FCKeditor.Java/trunk/src/site/apt/upgrade_notes.apt.vm	(revision 2702)
@@ -34,18 +34,23 @@
 
 *-------------------------------+----------------------------------------------+
-|| Ticket						|| Advice									  ||
+|| Ticket						|| Remark									  ||
 *-------------------------------+----------------------------------------------+
-| {{{${ticketUrl}/2618}2618}}	| So far we have used ImageInfo which was incorporated into our core jar. We have refactored it and removed from our jar. It is now on Maven Central |
-|								| Repo. Maven users do not have to bother but those who don't use Maven please make sure that the ImageInfo jar is on your classpath. The jar is |
-|								| bundled with the binary distribution.			|
+| {{{${ticketUrl}/2618}2618}}	| So far we have used ImageInfo which was incorporated into our core jar. We have refactored it and removed from our jar. It is now on |
+|								| Maven Central Repo. Maven users do not have to bother but those who don't use Maven please make sure that the ImageInfo jar is on |
+|								| your classpath. The jar is bundled with the binary distribution. |
 *-------------------------------+----------------------------------------------+
 | {{{${ticketUrl}/2608}2608}}	| The FCKeditor value will now be passed as-is, whitespace won't be truncated anymore |
 *-------------------------------+----------------------------------------------+
-| {{{${ticketUrl}/2583}2583}}	| The ConnectorServlet will fail in some environments when the deployed war file won't be expanded. If this happens, the ConnectorServlet will emit an |
-|								| appropriate log message. Consider to switch to another {{{connector.html}Connector}}. |
+| {{{${ticketUrl}/2583}2583}}	| The ConnectorServlet will fail in some environments when the deployed war file won't be expanded. If this happens, the ConnectorServlet |
+|								| will emit an appropriate log message. Consider to switch to another {{{connector.html}Connector}}. |
 *-------------------------------+----------------------------------------------+
-| {{{${ticketUrl}/2582}2582}}	| Path handling has been aligned to other connector implementations. The FullUrl property is gone. the UserFilesPath has slightly changed semantics and |
-|								| an UserFilesAbsolutePath property has beeen introduced. Please check the {{{properties.html}Configuration}} for more details. |
+| {{{${ticketUrl}/2582}2582}}	| Path handling has been aligned to other connector implementations. The FullUrl property is gone. the UserFilesPath has slightly changed |
+|								| semantics and an UserFilesAbsolutePath property has beeen introduced. Please check the {{{properties.html}Configuration}} for more details. |
 *-------------------------------+----------------------------------------------+
 | {{{${ticketUrl}/2580}2580}}	| The implementation <<<{{{java-core/apidocs/net/fckeditor/requestcycle/impl/UserActionImpl.html}UserActionImpl}}>>> has been deprecated in favor of <<<{{{java-core/apidocs/net/fckeditor/requestcycle/impl/EnabledUserAction.html}EnabledUserAction}}>>>. Both classes are functionally equal. |
 *-------------------------------+----------------------------------------------+
+| {{{${ticketUrl}/2383}2383}}	| We provide for every interface several implemenations. If you don't pick any particaluar implementation, don't worry, we will pick a |
+|								| suitable one for you.						   |
+*-------------------------------+----------------------------------------------+
+| {{{${ticketUrl}/2382}2382}}	| The <<<{{{java-core/apidocs/net/fckeditor/requestcycle/UserAction.html}UserAction}}>>> interface has now one more method <<<{{{java-core/apidocs/net/fckeditor/requestcycle/UserAction.html#isEnabledForFolderCreation(javax.servlet.http.HttpServletRequest)}isEnabledForFolderCreation}}>>>. If you have deployed your own implemenation, please adapt it. |
+*-------------------------------+----------------------------------------------+