Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Dispatcher.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Dispatcher.java	(revision 2703)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Dispatcher.java	(revision 2704)
@@ -94,5 +94,4 @@
 			final HttpServletResponse response) throws IOException {
 		logger.debug("Entering Dispatcher#doGet");
-		// TODO do we really need this wrapper?
 		Context context = ThreadLocalData.getContext();
 
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java	(revision 2703)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java	(revision 2704)
@@ -29,6 +29,5 @@
 /**
  * Handler for Connector-related properties.<br />
- * Wraps to the {@link PropertiesLoader}. TODO improve documentation of the
- * property key mapping
+ * Wraps to the {@link PropertiesLoader}.
  * 
  * @version $Id$
@@ -61,7 +60,7 @@
 
 	/**
-	 * Getter for the <code>UserFilesPath</code>.
+	 * Getter for <code>connector.userFilesPath</code> property
 	 * 
-	 * @return UserFilePath
+	 * @return UserFilesPath
 	 */
 	public static String getUserFilesPath() {
@@ -70,5 +69,5 @@
 
 	/**
-	 * Getter for the <code>UserFilesAbsolutePath</code>.
+	 * Getter for <code>connector.userFilesAbsolutePath</code> property
 	 * 
 	 * @return UserFilesAbsolutePath
@@ -79,8 +78,7 @@
 
 	/**
-	 * Getter for the default handling of files with multiple extensions.
+	 * Getter for <code>connector.forceSingleExtension</code> property
 	 * 
-	 * @return <code>true</code> if single extension only should be enforced
-	 *         else <code>false</code>.
+	 * @return ForceSingleExtension
 	 */
 	public static boolean isForceSingleExtension() {
@@ -90,9 +88,7 @@
 
 	/**
-	 * Getter for the value to instruct the Connector to check if the uploaded
-	 * image is really an image.
+	 * Getter for <code>connector.secureImageUploads</code> property
 	 * 
-	 * @return Boolean value of the property
-	 *         <code>connector.secureImageUploads</code>.
+	 * @return SecureImageUploads
 	 */
 	public static boolean isSecureImageUploads() {
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/LocalizedMessages.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/LocalizedMessages.java	(revision 2703)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/LocalizedMessages.java	(revision 2704)
@@ -60,6 +60,5 @@
 	 * @return The LP instance with localized strings.
 	 */
-	public static LocalizedMessages getMessages(
-			HttpServletRequest request) {
+	public static LocalizedMessages getMessages(HttpServletRequest request) {
 
 		Locale locale;
@@ -145,44 +144,108 @@
 	}
 
+	/**
+	 * Getter for localized <code>message.compatible_browser.yes</code> property
+	 * 
+	 * @return CompatibleBrowserYes
+	 */
 	public String getCompatibleBrowser() {
 		return getString("message.compatible_browser.yes");
 	}
 
+	/**
+	 * Getter for localized <code>message.compatible_browser.no</code> property
+	 * 
+	 * @return CompatibleBrowserNo
+	 */
 	public String getNotCompatibleBrowser() {
 		return getString("message.compatible_browser.no");
 	}
 
+	/**
+	 * Getter for localized <code>message.connector.fileUpload.enabled</code>
+	 * property
+	 * 
+	 * @return FileUploadEnabled
+	 */
 	public String getFileUploadEnabled() {
 		return getString("message.connector.fileUpload.enabled");
 	}
 
+	/**
+	 * Getter for localized <code>message.connector.fileUpload.disabled</code>
+	 * property
+	 * 
+	 * @return FileUploadDisabled
+	 */
 	public String getFileUploadDisabled() {
 		return getString("message.connector.fileUpload.disabled");
 	}
 
+	/**
+	 * Getter for localized <code>message.connector.fileBrowsing.enabled</code>
+	 * property
+	 * 
+	 * @return FileBrowsingEnabled
+	 */
 	public String getFileBrowsingEnabled() {
 		return getString("message.connector.fileBrowsing.enabled");
 	}
 
+	/**
+	 * Getter for localized <code>message.connector.fileBrowsing.disabled</code>
+	 * property
+	 * 
+	 * @return FileBrowsingDisabled
+	 */
 	public String getFileBrowsingDisabled() {
 		return getString("message.connector.fileBrowsing.disabled");
 	}
 
+	/**
+	 * Getter for localized
+	 * <code>message.connector.folderCreation.enabled</code> property
+	 * 
+	 * @return FolderCreationEnabled
+	 */
 	public String getFolderCreationEnabled() {
 		return getString("message.connector.folderCreation.enabled");
 	}
 
+	/**
+	 * Getter for localized
+	 * <code>message.connector.folderCreation.disabled</code> property
+	 * 
+	 * @return FolderCreationDisabled
+	 */
 	public String getFolderCreationDisabled() {
 		return getString("message.connector.folderCreation.disabled");
 	}
 
+	/**
+	 * Getter for localized
+	 * <code>message.connector.invalid_command_specified</code> property
+	 * 
+	 * @return InvalidCommandSpecified
+	 */
 	public String getInvalidCommand() {
 		return getString("message.connector.invalid_command_specified");
 	}
 
+	/**
+	 * Getter for localized
+	 * <code>message.connector.invalid_type_specified</code> property
+	 * 
+	 * @return InvalidTypeSpecified
+	 */
 	public String getInvalidType() {
 		return getString("message.connector.invalid_type_specified");
 	}
 
+	/**
+	 * Getter for localized
+	 * <code>message.connector.invalid_current_folder_speficied</code> property
+	 * 
+	 * @return InvalidCurrentFolderSpecified
+	 */
 	public String getInvalidCurrentFolder() {
 		return getString("message.connector.invalid_current_folder_speficied");