Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Connector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Connector.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Connector.java	(revision 2741)
@@ -21,4 +21,5 @@
 package net.fckeditor.connector;
 
+import java.io.IOException;
 import java.io.InputStream;
 import java.util.List;
@@ -30,8 +31,8 @@
 import net.fckeditor.connector.exception.InvalidCurrentFolderException;
 import net.fckeditor.connector.exception.InvalidNewFolderNameException;
-import net.fckeditor.connector.exception.WriteException;
 import net.fckeditor.handlers.ResourceType;
 
 /**
+ * TODO Review documentation
  * Interface for all Connectors.<br>
  * The Connector will be initialized by the {@link Dispatcher}. If an error is
@@ -130,5 +131,5 @@
 	 * @return <code>fileName</code> or the name of the renamed file.
 	 * @throws InvalidCurrentFolderException
-	 * @throws WriteException
+	 * @throws IOException
 	 * @throws SecurityException
 	 */
@@ -137,5 +138,5 @@
 			final InputStream inputStream)
 			throws InvalidCurrentFolderException, SecurityException,
-			WriteException;
+			IOException;
 
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/ConnectorServlet.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/ConnectorServlet.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/ConnectorServlet.java	(revision 2741)
@@ -34,4 +34,5 @@
 
 /**
+ * TODO Review documentation
  * This is the FCKeditor Connector servlet. It has the following jobs:
  * <ul>
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Dispatcher.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Dispatcher.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/Dispatcher.java	(revision 2741)
@@ -32,5 +32,4 @@
 import net.fckeditor.connector.exception.InvalidCurrentFolderException;
 import net.fckeditor.connector.exception.InvalidNewFolderNameException;
-import net.fckeditor.connector.exception.WriteException;
 import net.fckeditor.handlers.Command;
 import net.fckeditor.handlers.ConnectorHandler;
@@ -56,4 +55,5 @@
 
 /**
+ * TODO Review documentation
  * This class is called by {@link ConnectorServlet}. It verifies the request
  * parameters and forwards them to the corresponding {@link Connector} methods.
@@ -292,5 +292,6 @@
 			} catch (SecurityException e) {
 				uploadResponse = UploadResponse.getErrorSecurity();
-			} catch (WriteException e) {
+			} catch (IOException e) {
+				// TODO handle it maybe better?!
 				uploadResponse = UploadResponse.getErrorUnknown();
 			} catch (FileUploadException e) {
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/FolderAlreadyExistsException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/FolderAlreadyExistsException.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/FolderAlreadyExistsException.java	(revision 2741)
@@ -25,8 +25,9 @@
 
 /**
- * Signals that a {@link Connector} method tried to create a folder that already exists. <br>
- * <br> 
- * These is an exception to signal the {@link Dispatcher} what was going wrong.
- *
+ * Signals that a {@link Connector} method tried to create a folder which
+ * already exists. <br />
+ * <br />
+ * This is an exception to signal the {@link Dispatcher} what was going wrong.
+ * 
  * @version $Id$
  */
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidCurrentFolderException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidCurrentFolderException.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidCurrentFolderException.java	(revision 2741)
@@ -25,9 +25,9 @@
 
 /**
- * Signals that a {@link Connector} method can't find the current folder. That's 
- * never happened in common cases.<br>
- * <br> 
- * These is an exception to signal the {@link Dispatcher} what was going wrong.
- *
+ * Signals that a {@link Connector} method can't find the current folder. This
+ * should never happen in the common case.<br />
+ * <br />
+ * This is an exception to signal the {@link Dispatcher} what was going wrong.
+ * 
  * @version $Id$
  */
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidNewFolderNameException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidNewFolderNameException.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidNewFolderNameException.java	(revision 2741)
@@ -25,8 +25,9 @@
 
 /**
- * Signals that a {@link Connector} method tried to create a folder and it fails. <br>
- * <br> 
- * These is an exception to signal the {@link Dispatcher} what was going wrong.
- *
+ * Signals that a {@link Connector} method tried to create a folder and it
+ * failed. <br />
+ * <br />
+ * This is an exception to signal the {@link Dispatcher} what was going wrong.
+ * 
  * @version $Id$
  */
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/UnknownException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/UnknownException.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/UnknownException.java	(revision 2741)
@@ -24,8 +24,8 @@
 
 /**
- * Signals an undefined exception.<br>
- * <br> 
- * These is an exception to signal the {@link Dispatcher} what was going wrong.
- *
+ * Signals an undefined exception.<br />
+ * <br />
+ * This is an exception to signal the {@link Dispatcher} what was going wrong.
+ * 
  * @version $Id$
  */
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/WriteException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/WriteException.java	(revision 2739)
+++ 	(revision )
@@ -1,35 +1,0 @@
-/*
- * FCKeditor - The text editor for Internet - http://www.fckeditor.net
- * Copyright (C) 2003-2008 Frederico Caldeira Knabben
- * 
- * == BEGIN LICENSE ==
- * 
- * Licensed under the terms of any of the following licenses at your
- * choice:
- * 
- *  - GNU General Public License Version 2 or later (the "GPL")
- *    http://www.gnu.org/licenses/gpl.html
- * 
- *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
- *    http://www.gnu.org/licenses/lgpl.html
- * 
- *  - Mozilla Public License Version 1.1 or later (the "MPL")
- *    http://www.mozilla.org/MPL/MPL-1.1.html
- * 
- * == END LICENSE ==
- */
-package net.fckeditor.connector.exception;
-
-import net.fckeditor.connector.Dispatcher;
-
-/**
- * Thrown to indicate that during file write action an error has occured.
- * These is an exception to signal the {@link Dispatcher} what was going wrong.
- *
- * @version $Id$
- */
-public class WriteException extends Exception {
-
-	private static final long serialVersionUID = 7742121738185371543L;
-
-}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/AbstracLocalFileSystemConnector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/AbstracLocalFileSystemConnector.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/AbstracLocalFileSystemConnector.java	(revision 2741)
@@ -24,4 +24,5 @@
 import java.io.FileFilter;
 import java.io.FileOutputStream;
+import java.io.IOException;
 import java.io.InputStream;
 import java.util.ArrayList;
@@ -37,5 +38,4 @@
 import net.fckeditor.connector.exception.InvalidCurrentFolderException;
 import net.fckeditor.connector.exception.InvalidNewFolderNameException;
-import net.fckeditor.connector.exception.WriteException;
 import net.fckeditor.handlers.ConnectorHandler;
 import net.fckeditor.handlers.RequestCycleHandler;
@@ -49,4 +49,5 @@
 
 /**
+ * TODO Review documentation
  * Implementation of the {@link Connector} for the file system. All path are
  * interpreted as sub-directories of the
@@ -68,5 +69,5 @@
 			final String currentFolder, final String fileName,
 			final InputStream inputStream) throws SecurityException,
-			InvalidCurrentFolderException, WriteException {
+			InvalidCurrentFolderException, IOException {
 		String absolutePath = getRealUserFilesAbsolutePath(RequestCycleHandler
 				.getUserFilesAbsolutePath(ThreadLocalData.getRequest()));
@@ -77,4 +78,6 @@
 		File newFile = new File(currentDir, fileName);
 		File fileToSave = UtilsFile.getUniqueFile(newFile.getAbsoluteFile());
+		
+		// TODO maybe there is no need to catch and rethrow the exceptions, we may just pass them as-is
 		try {
 			IOUtils.copyLarge(inputStream, new FileOutputStream(fileToSave));
@@ -83,6 +86,6 @@
 			// SecurityManager is deployed, this could restrict writing on disk
 			throw e;
-		} catch (Exception e) {
-			throw new WriteException();
+		} catch (IOException e) {
+			throw e;
 		}
 		return fileToSave.getName();
@@ -107,4 +110,5 @@
 			throw new InvalidCurrentFolderException();
 		File newDir = new File(currentDir, newFolder);
+		// TODO maybe there is no need to catch and rethrow the exceptions, we may just pass them as-is
 		if (newDir.exists())
 			throw new FolderAlreadyExistsException();
@@ -136,4 +140,5 @@
 		List<Map<String, Object>> files;
 		Map<String, Object> fileMap;
+		// TODO maybe there is no need to catch and rethrow the exceptions, we may just pass them as-is
 		try {
 			File[] fileList = currentDir
@@ -168,4 +173,5 @@
 			throw new InvalidCurrentFolderException();
 
+		// TODO maybe there is no need to catch and rethrow the exceptions, we may just pass them as-is
 		try {
 			String[] fileList = currentDir.list(DirectoryFileFilter.DIRECTORY);
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/ContextConnector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/ContextConnector.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/ContextConnector.java	(revision 2741)
@@ -23,12 +23,11 @@
 import javax.servlet.ServletContext;
 
+import net.fckeditor.handlers.PropertiesLoader;
+
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
-import net.fckeditor.handlers.ConnectorHandler;
-import net.fckeditor.handlers.PropertiesLoader;
-
 /**
- * TODO Document this, especially for ticket #2583
+ * TODO Review documentation
  * 
  * @version $Id$
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/LocalConnector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/LocalConnector.java	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/LocalConnector.java	(revision 2741)
@@ -24,5 +24,5 @@
 
 /**
- * 
+ * TODO Review documentation
  * @version $Id$
  */
Index: FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/connector/exception/package.html
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/connector/exception/package.html	(revision 2741)
+++ FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/connector/exception/package.html	(revision 2741)
@@ -0,0 +1,59 @@
+<!--
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ *
+ * == BEGIN LICENSE ==
+ *
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ *
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ *
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ *
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ *
+ * == END LICENSE ==
+ * @version: $Id$
+-->
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
+<html>
+<head>
+</head>
+<body bgcolor="white">
+
+This package contains all custom exceptions which may be thrown by a
+{@link net.fckeditor.connector.Connector Connector} implementation.
+<br />
+Note: These exceptions won't be logged nor will be the
+<code>getMessage</code>
+method called to pass the message to the user. Instead, the exception
+simply indicates the system state which will be propagated to the user
+by the a localized message of the system.
+
+<h2>Additional Exceptions</h2>
+
+More over you may throw following standard exceptions to indicate a
+system failure:
+<ul>
+	<li><code><a
+		href="http://java.sun.com/j2se/1.5.0/docs/api/java/io/IOException.html"
+		target="_blank">IOException</a></code>: Indicates that the failure of a file
+	write action.
+	<li><code><a
+		href="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/SecurityException.html"
+		target="_blank">SecurityException</a></code>: Indicates that the file or
+	folder action has been denied according to the underlying <code><a
+		href="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/SecurityManager.html"
+		target="_blank">SecurityManager</a></code> or the user has no rights to
+	perform this action according to a {@link
+	net.fckeditor.requestcycle.UserAction UserAction} implementation.
+</ul>
+
+<!-- Put @see and @since tags down here. -->
+
+</body>
+</html>
Index: FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/connector/package.html
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/connector/package.html	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/connector/package.html	(revision 2741)
@@ -26,5 +26,6 @@
 <body bgcolor="white">
 
-Connector used by the FCKeditor to list and create resources on the server.
+This package covers all request-related classes and implementations which handle
+resource management requests from the user.
 
 <h2>Related Documentation</h2>
@@ -32,6 +33,6 @@
 For overviews, tutorials, examples, guides, and tool documentation, please see:
 <ul>
-  <li>The official FCKeditor.Java integration <a href="http://java.fckeditor.net">website</a>.
-  <li>The example web application. 
+  <li>The official FCKeditor.Java integration <a href="http://java.fckeditor.net" target="_blank">website</a>.
+  <li>The <a href="http://java.fckeditor.net/demo.html" target="_blank">example web application</a>. 
 </ul>
 
Index: FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/package.html
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/package.html	(revision 2739)
+++ FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/package.html	(revision 2741)
@@ -32,5 +32,5 @@
 For overviews, tutorials, examples, guides, and tool documentation, please see:
 <ul>
-  <li><a href="http://docs.fckeditor.net/">Official documenation of the FCKeditor</a>.
+  <li><a href="http://docs.fckeditor.net/" target="_blank">Official documentation of the FCKeditor</a>.
 </ul>
 