Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/FCKeditor.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/FCKeditor.java	(revision 2741)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/FCKeditor.java	(revision 2742)
@@ -245,6 +245,4 @@
 	/**
 	 * This method simply wraps to {@link #createHtml()}.
-	 * 
-	 * @see #createHtml()
 	 */
 	@Override
@@ -307,4 +305,5 @@
 	}
 
+	// TODO review documentation
 	private String createInputForVariable(final String name, final String id,
 			final String value) {
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/FCKeditorConfig.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/FCKeditorConfig.java	(revision 2741)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/FCKeditorConfig.java	(revision 2742)
@@ -46,11 +46,4 @@
 
 	/**
-	 * Initialize the configuration collection
-	 */
-	public FCKeditorConfig() {
-		super();
-	}
-
-	/**
 	 * Generates the URL parameter sequence from this configuration which is
 	 * passed to the editor.
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/ConnectorServlet.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/ConnectorServlet.java	(revision 2741)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/ConnectorServlet.java	(revision 2742)
@@ -70,5 +70,4 @@
 	 * Initializes the {@link Dispatcher}.
 	 * 
-	 * @see javax.servlet.GenericServlet#init()
 	 */
 	@Override
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/AbstracLocalFileSystemConnector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/AbstracLocalFileSystemConnector.java	(revision 2741)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/AbstracLocalFileSystemConnector.java	(revision 2742)
@@ -42,4 +42,5 @@
 import net.fckeditor.handlers.ResourceType;
 import net.fckeditor.requestcycle.ThreadLocalData;
+import net.fckeditor.requestcycle.UserPathBuilder;
 import net.fckeditor.tool.UtilsFile;
 
@@ -49,10 +50,13 @@
 
 /**
- * TODO Review documentation
- * Implementation of the {@link Connector} for the file system. All path are
- * interpreted as sub-directories of the
- * {@link ConnectorHandler#getUserFilesPath()}.<br>
- * 
- * @version $Id$
+ * This class provides an abstract implementation of the {@link Connector}
+ * interface with the default behavior according to the <a href="http://docs.fckeditor.net/FCKeditor_2.x/Developers_Guide/Server_Side_Integration"
+ * target="_blank">documentation</a>. It serves files and folders against a
+ * specific local directory. You cannot use this class directly, instead you
+ * have to subclass it and implement the interface/abstract methods. There are
+ * two ready to go subclasses, see above.
+ * 
+ * @version $Id: AbstracLocalFileSystemConnector.java 2741 2008-11-29 14:06:19Z
+ *          mosipov $
  */
 public abstract class AbstracLocalFileSystemConnector implements Connector {
@@ -78,6 +82,7 @@
 		File newFile = new File(currentDir, fileName);
 		File fileToSave = UtilsFile.getUniqueFile(newFile.getAbsoluteFile());
-		
-		// TODO maybe there is no need to catch and rethrow the exceptions, we may just pass them as-is
+
+		// TODO maybe there is no need to catch and rethrow the exceptions, we
+		// may just pass them as-is
 		try {
 			IOUtils.copyLarge(inputStream, new FileOutputStream(fileToSave));
@@ -110,5 +115,6 @@
 			throw new InvalidCurrentFolderException();
 		File newDir = new File(currentDir, newFolder);
-		// TODO maybe there is no need to catch and rethrow the exceptions, we may just pass them as-is
+		// TODO maybe there is no need to catch and rethrow the exceptions, we
+		// may just pass them as-is
 		if (newDir.exists())
 			throw new FolderAlreadyExistsException();
@@ -140,5 +146,6 @@
 		List<Map<String, Object>> files;
 		Map<String, Object> fileMap;
-		// TODO maybe there is no need to catch and rethrow the exceptions, we may just pass them as-is
+		// TODO maybe there is no need to catch and rethrow the exceptions, we
+		// may just pass them as-is
 		try {
 			File[] fileList = currentDir
@@ -173,5 +180,6 @@
 			throw new InvalidCurrentFolderException();
 
-		// TODO maybe there is no need to catch and rethrow the exceptions, we may just pass them as-is
+		// TODO maybe there is no need to catch and rethrow the exceptions, we
+		// may just pass them as-is
 		try {
 			String[] fileList = currentDir.list(DirectoryFileFilter.DIRECTORY);
@@ -182,6 +190,29 @@
 	}
 
+	/**
+	 * This method shall resolve the
+	 * {@link UserPathBuilder#getUserFilesAbsolutePath(javax.servlet.http.HttpServletRequest)
+	 * UserFilesAbsolutePath} against a specific system. E.g., local filesystem
+	 * or context filesystem. It's up to you what it returns but make sure that
+	 * it's consistent inside the entire cycle.
+	 * 
+	 * @param path
+	 *            The path to resolve.
+	 * @return The resolved path.
+	 */
 	protected abstract String getRealUserFilesAbsolutePath(String path);
 
+	/**
+	 * This method simply checks if the the resource type dir exists and creates
+	 * it if necessary.
+	 * 
+	 * @param baseDir
+	 *            BaseDir for the resource type.
+	 * @param type
+	 *            Resource type to mkdir.
+	 * @return The file object of the resource type.
+	 * @throws SecurityException
+	 *             If a SecurityManager denies folder creation.
+	 */
 	private static File getOrCreateResourceTypeDir(final String baseDir,
 			final ResourceType type) throws SecurityException {
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/ContextConnector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/ContextConnector.java	(revision 2741)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/ContextConnector.java	(revision 2742)
@@ -29,5 +29,15 @@
 
 /**
- * TODO Review documentation
+ * This implementation represents a specific restriction against the local
+ * filesystem. It resolves any path against the current servlet context.
+ * <p>
+ * Though, this connector has some drawbacks:
+ * <ul>
+ * <li>Stored files will be gone if context will be undeployed, unless you have
+ * saved them before.</li>
+ * <li>Some servers are unable to write to the context path, see
+ * {@link #init(ServletContext)}.</li>
+ * </ul>
+ * </p>
  * 
  * @version $Id$
@@ -43,4 +53,14 @@
 	 * @see net.fckeditor.connector.Connector#init()
 	 */
+	/**
+	 * This method will prepare the connector for further usage, additionally it
+	 * will check if the aforementioned drawback exists. It will try to resolve
+	 * the default {@link PropertiesLoader#getUserFilesPath() UserFilesPath}
+	 * with
+	 * <code><a href="http://tomcat.apache.org/tomcat-5.5-doc/servletapi/javax/servlet/ServletContext.html#getRealPath(java.lang.String)"
+	 * target="_blank">ServletContext.getRealPath(String)</a></code> against the
+	 * local filesystem (real path). If it fails, it will emit helpful log
+	 * messages and will throw an exception too.
+	 */
 	public void init(final ServletContext servletContext) throws Exception {
 
@@ -50,7 +70,10 @@
 
 		if (defaultAbsolutePath == null) {
-			logger.error("The context root cannot be resolved against the local filesystem");
-			logger.info("Your servlet container/application server does not expand deployed war files");
-			logger.debug("Use another Connector implementation (e.g. LocalConnector) and consult http://www.fckeditor.net/forums/viewtopic.php?f=6&t=11568");
+			logger
+					.error("The context root cannot be resolved against the local filesystem");
+			logger
+					.info("Your servlet container/application server does not expand deployed war files");
+			logger
+					.debug("Use another Connector implementation (e.g. LocalConnector) and consult http://www.fckeditor.net/forums/viewtopic.php?f=6&t=11568");
 			throw new NullPointerException(
 					"The context root cannot be resolved against the local filesystem");
@@ -58,4 +81,8 @@
 	}
 
+	/**
+	 * Returns the given path resolved against the dynamic context and the real
+	 * filesystem.
+	 */
 	@Override
 	protected String getRealUserFilesAbsolutePath(String path) {
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/LocalConnector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/LocalConnector.java	(revision 2741)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/LocalConnector.java	(revision 2742)
@@ -24,18 +24,24 @@
 
 /**
- * TODO Review documentation
+ * This is a very shallow and simple implementation. It assigns/returns the
+ * least amount of variables to work with the direct local filesystem.<br />
+ * You may call this implementation and identity implementation:
+ * <code>f(x)=x</code>.
+ * 
  * @version $Id$
  */
 public class LocalConnector extends AbstracLocalFileSystemConnector {
 
-	/*
-	 * (non-Javadoc)
-	 * 
-	 * @see net.fckeditor.connector.Connector#init()
+	/**
+	 * This method simply assigns the servlet context to the underlying instance
+	 * field.
 	 */
 	public void init(final ServletContext servletContext) throws Exception {
 		AbstracLocalFileSystemConnector.servletContext = servletContext;
 	}
-	
+
+	/**
+	 * This is an identity implementation, it passes the path as-is.
+	 */
 	@Override
 	protected String getRealUserFilesAbsolutePath(String path) {
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tool/XHtmlTagTool.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tool/XHtmlTagTool.java	(revision 2741)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/tool/XHtmlTagTool.java	(revision 2742)
@@ -92,6 +92,4 @@
 	/**
 	 * Constructs the tag.
-	 * 
-	 * @see java.lang.Object#toString()
 	 */
 	@Override
Index: FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/connector/impl/package.html
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/connector/impl/package.html	(revision 2742)
+++ FCKeditor.Java/trunk/java-core/src/main/javadoc/net/fckeditor/connector/impl/package.html	(revision 2742)
@@ -0,0 +1,35 @@
+<!--
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ *
+ * == BEGIN LICENSE ==
+ *
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ *
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ *
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ *
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ *
+ * == END LICENSE ==
+ * @version: $Id$
+-->
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
+<html>
+<head>
+</head>
+<body bgcolor="white">
+
+This package contains our implementations of the {@link
+net.fckeditor.connector.Connector} interface. It consists of an abstract
+implementation and two specific subclassed connectors.
+
+<!-- Put @see and @since tags down here. -->
+
+</body>
+</html>